﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using EntityCodeFirst.Models;
using System.Data.Entity;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using System.Collections;

namespace EntityCodeFirst.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()            
        {          
            return View();
        }

        //Provide grid datasource
        public ActionResult GetOrderData(DataManager dm)
        {
            IEnumerable data = new OrderContext().OrderTables.ToList();
            int count = new OrderContext().OrderTables.ToList().Count;

            DataOperations operation = new DataOperations();
            //Performing filtering operation
            if (dm.Where != null)
            {
                data = operation.PerformWhereFilter(data, dm.Where, "and");
                var filtered = (IEnumerable<object>)data;
                count = filtered.Count();
            }

            //Performing sorting operation
            if (dm.Sorted != null)
                data = operation.PerformSorting(data, dm.Sorted);

            //Performing paging operations
            data = operation.PerformSkip(data, dm.Skip);
            data = operation.PerformTake(data, dm.Take);
           
            return Json(new { result = data, count = count }, JsonRequestBehavior.AllowGet);

        }

        //Perform file insertion 
        public ActionResult PerformInsert(EditParams param)
        {
            
            OrderContext db = new OrderContext();
            db.OrderTables.Add(param.value);
            db.SaveChanges();

            return RedirectToAction("GetOrderData");
        }

        //Perform update
        public ActionResult PerformUpdate(EditParams param)
        {

            OrderContext db = new OrderContext();
            OrderTable table = db.OrderTables.Single(o => o.OrderID == param.value.OrderID);

            db.Entry(table).CurrentValues.SetValues(param.value);
            db.Entry(table).State = EntityState.Modified;
            db.SaveChanges();

            return RedirectToAction("GetOrderData");
        }

        //Perform delete
        public ActionResult PerformDelete(int key, string keyColumn)
        {

            OrderContext db = new OrderContext();
            db.OrderTables.Remove(db.OrderTables.Single(o => o.OrderID == key));
            db.SaveChanges();
            return RedirectToAction("GetOrderData");
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }


}